# Interface CAI1LocationMatch

All Superinterfaces:
  `com.io7m.cedarbridge.runtime.api.CBSerializableType`

All Known Implementing Classes:
  `CAI1LocationMatch.CAI1LocationAny`, `CAI1LocationMatch.CAI1LocationExact`, `CAI1LocationMatch.CAI1LocationWithDescendants`

public sealed interface CAI1LocationMatch extends com.io7m.cedarbridge.runtime.api.CBSerializableType permits CAI1LocationMatch.CAI1LocationExact, CAI1LocationMatch.CAI1LocationWithDescendants, CAI1LocationMatch.CAI1LocationAny
The behaviour requested for matching locations.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Interface
  Description
  `static final record`
  `CAI1LocationMatch.CAI1LocationAny`
  Consider all locations.
  `static final record`
  `CAI1LocationMatch.CAI1LocationExact`
  Only consider the exact given location.
  `static final record`
  `CAI1LocationMatch.CAI1LocationWithDescendants`
  Consider the given location and all descendants of the given location.

- ## Method Summary

  Static Methods
  Modifier and Type
  Method
  Description
  `static CAI1LocationMatch`
  `deserialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context)`
  Deserialize a value of type CAI1LocationMatch.
  `static void`
  `serialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context, CAI1LocationMatch $x)`
  Serialize a value of type CAI1LocationMatch.

- ## Method Details

  - ### serialize

    static void serialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context, CAI1LocationMatch $x) throws IOException
    Serialize a value of type CAI1LocationMatch.
    Parameters:
      `$context` - The serialization context.
      `$x` - The value to be serialized.
    Throws:
      `IOException`

  - ### deserialize

    static CAI1LocationMatch deserialize(com.io7m.cedarbridge.runtime.api.CBSerializationContextType $context) throws IOException
    Deserialize a value of type CAI1LocationMatch.
    Parameters:
      `$context` - The serialization context.
    Returns:
      A value of type CAI1LocationMatch.
    Throws:
      `IOException`